<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>StaticHostProvider.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.client</a> &gt; <span class="el_source">StaticHostProvider.java</span></div><h1>StaticHostProvider.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.client;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * Most simple HostProvider, resolves only on instantiation.
 * 
 */
public final class StaticHostProvider implements HostProvider {
<span class="fc" id="L38">    private static final Logger LOG = LoggerFactory</span>
<span class="fc" id="L39">            .getLogger(StaticHostProvider.class);</span>

<span class="fc" id="L41">    private final List&lt;InetSocketAddress&gt; serverAddresses = new ArrayList&lt;InetSocketAddress&gt;(</span>
            5);

<span class="fc" id="L44">    private int lastIndex = -1;</span>

<span class="fc" id="L46">    private int currentIndex = -1;</span>

    /**
     * Constructs a SimpleHostSet.
     * 
     * @param serverAddresses
     *            possibly unresolved ZooKeeper server addresses
     * @throws UnknownHostException
     * @throws IllegalArgumentException
     *             if serverAddresses is empty or resolves to an empty list
     */
    public StaticHostProvider(Collection&lt;InetSocketAddress&gt; serverAddresses)
<span class="fc" id="L58">            throws UnknownHostException {</span>
<span class="fc bfc" id="L59" title="All 2 branches covered.">        for (InetSocketAddress address : serverAddresses) {</span>
<span class="fc" id="L60">            InetAddress ia = address.getAddress();</span>
<span class="fc bfc" id="L61" title="All 2 branches covered.">            InetAddress resolvedAddresses[] = InetAddress.getAllByName((ia!=null) ? ia.getHostAddress():</span>
<span class="fc" id="L62">                address.getHostName());</span>
<span class="fc bfc" id="L63" title="All 2 branches covered.">            for (InetAddress resolvedAddress : resolvedAddresses) {</span>
                // If hostName is null but the address is not, we can tell that
                // the hostName is an literal IP address. Then we can set the host string as the hostname
                // safely to avoid reverse DNS lookup.
                // As far as i know, the only way to check if the hostName is null is use toString().
                // Both the two implementations of InetAddress are final class, so we can trust the return value of
                // the toString() method.
<span class="fc bfc" id="L70" title="All 2 branches covered.">                if (resolvedAddress.toString().startsWith(&quot;/&quot;) </span>
<span class="pc bpc" id="L71" title="1 of 2 branches missed.">                        &amp;&amp; resolvedAddress.getAddress() != null) {</span>
<span class="fc" id="L72">                    this.serverAddresses.add(</span>
<span class="fc" id="L73">                            new InetSocketAddress(InetAddress.getByAddress(</span>
<span class="fc" id="L74">                                    address.getHostName(),</span>
<span class="fc" id="L75">                                    resolvedAddress.getAddress()), </span>
<span class="fc" id="L76">                                    address.getPort()));</span>
                } else {
<span class="fc" id="L78">                    this.serverAddresses.add(new InetSocketAddress(resolvedAddress.getHostAddress(), address.getPort()));</span>
                }  
            }
<span class="fc" id="L81">        }</span>
        
<span class="pc bpc" id="L83" title="1 of 2 branches missed.">        if (this.serverAddresses.isEmpty()) {</span>
<span class="nc" id="L84">            throw new IllegalArgumentException(</span>
                    &quot;A HostProvider may not be empty!&quot;);
        }
<span class="fc" id="L87">        Collections.shuffle(this.serverAddresses);</span>
<span class="fc" id="L88">    }</span>

    public int size() {
<span class="fc" id="L91">        return serverAddresses.size();</span>
    }

    public InetSocketAddress next(long spinDelay) {
<span class="fc" id="L95">        ++currentIndex;</span>
<span class="fc bfc" id="L96" title="All 2 branches covered.">        if (currentIndex == serverAddresses.size()) {</span>
<span class="fc" id="L97">            currentIndex = 0;</span>
        }
<span class="fc bfc" id="L99" title="All 4 branches covered.">        if (currentIndex == lastIndex &amp;&amp; spinDelay &gt; 0) {</span>
            try {
<span class="fc" id="L101">                Thread.sleep(spinDelay);</span>
<span class="nc" id="L102">            } catch (InterruptedException e) {</span>
<span class="nc" id="L103">                LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="pc" id="L104">            }</span>
<span class="fc bfc" id="L105" title="All 2 branches covered.">        } else if (lastIndex == -1) {</span>
            // We don't want to sleep on the first ever connect attempt.
<span class="fc" id="L107">            lastIndex = 0;</span>
        }

<span class="fc" id="L110">        return serverAddresses.get(currentIndex);</span>
    }

    public void onConnected() {
<span class="fc" id="L114">        lastIndex = currentIndex;</span>
<span class="fc" id="L115">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>